// urlmonikerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "urlmoniker.h"
#include "urlmonikerDlg.h"
#include "bindcallback.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUrlmonikerDlg dialog

CUrlmonikerDlg::CUrlmonikerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUrlmonikerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUrlmonikerDlg)
	m_DataEdit = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CUrlmonikerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUrlmonikerDlg)
	DDX_Control(pDX, IDC_TIMEOUTSEC, m_TimeoutEdit);
	DDX_Control(pDX, IDC_COMBO1, m_URLCombo);
	DDX_Control(pDX, IDC_BIND, m_BindButton);
	DDX_Control(pDX, IDC_PROGRESS1, m_Progress);
	DDX_Text(pDX, IDC_DATAEDIT, m_DataEdit);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CUrlmonikerDlg, CDialog)
	//{{AFX_MSG_MAP(CUrlmonikerDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BIND, OnBind)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUrlmonikerDlg message handlers

BOOL CUrlmonikerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	

	m_URLCombo.AddString ("http://www.rollthunder.com") ;
	m_URLCombo.AddString ("http://www.microsoft.com") ;
	m_URLCombo.AddString ("http://www.im.pw.edu.pl/jokes/lightbulb.html") ;

	SetDlgItemInt (IDC_TIMEOUTSEC, 5) ;

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CUrlmonikerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CUrlmonikerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CUrlmonikerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CUrlmonikerDlg::OnBind() 
{
	char name [256] ;
	USES_CONVERSION ;
	HRESULT hr ;

/*
Get name from edit control.  Use it to create an URL moniker.
*/

	m_URLCombo.GetWindowText (name, sizeof(name)) ;
	hr = CreateURLMoniker (NULL, A2W(name), &m_pUrlMoniker) ;	

	if (hr != S_OK)
	{
		AfxMessageBox ("No URL Moniker") ;
		return ;
	}

/*
Create a new bind status callback.
*/
	m_pBindStatusCallback = new CBindStatusCallback (this) ;

/*
Create a bind context.  Register the BindStatusCallback with it,
*/

	hr = CreateBindCtx (0, &m_pBindCtx) ;


	IBindStatusCallback *pPrev ;
	
	hr = RegisterBindStatusCallback (
		m_pBindCtx,
		m_pBindStatusCallback,
		&pPrev,
		NULL) ;

/*
Tell the moniker to bind to the storage.
*/

	hr = m_pUrlMoniker->BindToStorage (
		m_pBindCtx,
		0,
		IID_IStream,
		(void **)&m_pStream) ;

	if (hr != S_OK && hr != MK_S_ASYNCHRONOUS)
	{
		AfxMessageBox ("Couldn't bind moniker") ;
	}
	else
	{
		m_BindButton.EnableWindow (FALSE) ;
	}

}

void CUrlmonikerDlg::BindFinished( )
{
	m_pBindCtx->Release( ) ;
	m_pUrlMoniker->Release( ) ;
	m_pBindStatusCallback->Release ( ) ;

	m_BindButton.EnableWindow (TRUE) ;

}
